XYZ File Manager
Current Path:
/usr/bin
usr
/
bin
/
π
..
π
X11
π
[
(66.89 KB)
π
ab
(58.42 KB)
π
addpart
(30.31 KB)
π
apt
(18.31 KB)
π
apt-cache
(86.38 KB)
π
apt-cdrom
(22.38 KB)
π
apt-config
(26.31 KB)
π
apt-get
(50.38 KB)
π
apt-key
(27.32 KB)
π
apt-mark
(58.38 KB)
π
arch
(42.86 KB)
π
awk
(154.66 KB)
π
b2sum
(58.98 KB)
π
base32
(46.89 KB)
π
base64
(46.89 KB)
π
basename
(42.83 KB)
π
basenc
(54.89 KB)
π
bash
(1.21 MB)
π
bashbug
(6.7 KB)
π
bdftopcf
(42.45 KB)
π
bdftruncate
(10.22 KB)
π
busctl
(90.5 KB)
π
c_rehash
(6.68 KB)
π
captoinfo
(90.34 KB)
π
cat
(42.98 KB)
π
certbot
(958 B)
π
chage
(78.49 KB)
π
chardet
(221 B)
π
chardetect
(221 B)
π
chattr
(14.24 KB)
π
chcon
(67.11 KB)
π
checkgid
(14.23 KB)
π
chfn
(61.2 KB)
π
chgrp
(67.05 KB)
π
chmod
(62.98 KB)
π
choom
(54.31 KB)
π
chown
(71.05 KB)
π
chrt
(66.31 KB)
π
chsh
(51.64 KB)
π
cksum
(139.05 KB)
π
clear
(14.24 KB)
π
clear_console
(14.15 KB)
π
cmp
(50.95 KB)
π
comm
(46.92 KB)
π
corelist
(15.01 KB)
π
cp
(147.61 KB)
π
cpan
(8.16 KB)
π
cpan5.36-x86_64-linux-gnu
(8.18 KB)
π
csplit
(119.17 KB)
π
ctstat
(26.59 KB)
π
cut
(46.98 KB)
π
dash
(122.7 KB)
π
date
(119.05 KB)
π
dbus-cleanup-sockets
(14.22 KB)
π
dbus-daemon
(238.56 KB)
π
dbus-monitor
(26.23 KB)
π
dbus-run-session
(14.23 KB)
π
dbus-send
(30.22 KB)
π
dbus-update-activation-environment
(14.22 KB)
π
dbus-uuidgen
(14.22 KB)
π
dd
(87.15 KB)
π
deb-systemd-helper
(23.79 KB)
π
deb-systemd-invoke
(6.09 KB)
π
debconf
(2.79 KB)
π
debconf-apt-progress
(11.27 KB)
π
debconf-communicate
(608 B)
π
debconf-copydb
(1.68 KB)
π
debconf-escape
(647 B)
π
debconf-set-selections
(2.92 KB)
π
debconf-show
(1.78 KB)
π
delpart
(30.31 KB)
π
df
(99.8 KB)
π
dialog
(247.85 KB)
π
diff
(151.58 KB)
π
diff3
(67.14 KB)
π
dir
(147.8 KB)
π
dircolors
(50.92 KB)
π
dirname
(38.83 KB)
π
dmesg
(86.58 KB)
π
dnsdomainname
(22.15 KB)
π
domainname
(22.15 KB)
π
dpkg
(310.64 KB)
π
dpkg-deb
(166.52 KB)
π
dpkg-divert
(154.55 KB)
π
dpkg-maintscript-helper
(20.71 KB)
π
dpkg-query
(158.58 KB)
π
dpkg-realpath
(4.09 KB)
π
dpkg-split
(126.48 KB)
π
dpkg-statoverride
(62.33 KB)
π
dpkg-trigger
(86.48 KB)
π
du
(171.33 KB)
π
dvipdf
(1007 B)
π
echo
(42.83 KB)
π
editor
(3.48 MB)
π
egrep
(41 B)
π
enc2xs
(40.96 KB)
π
encguess
(3 KB)
π
env
(47.4 KB)
π
eps2eps
(639 B)
π
ex
(3.48 MB)
π
expand
(42.92 KB)
π
expiry
(30.45 KB)
π
expr
(115.05 KB)
π
factor
(83.2 KB)
π
faillog
(22.53 KB)
π
fallocate
(34.31 KB)
π
false
(34.83 KB)
π
fcgistarter
(14.23 KB)
π
fgrep
(41 B)
π
fincore
(34.36 KB)
π
find
(219.58 KB)
π
findmnt
(83.59 KB)
π
flock
(34.39 KB)
π
fmt
(46.89 KB)
π
fold
(42.89 KB)
π
fonttosfnt
(34.41 KB)
π
free
(26.3 KB)
π
fuser
(39.83 KB)
π
getconf
(26.5 KB)
π
getent
(35.47 KB)
π
getopt
(34.31 KB)
π
ghostscript
(14.23 KB)
π
gpasswd
(86.42 KB)
π
gpgv
(463 KB)
π
grep
(198.39 KB)
π
groups
(42.89 KB)
π
gs
(14.23 KB)
π
gsbj
(350 B)
π
gsdj
(352 B)
π
gsdj500
(352 B)
π
gslj
(353 B)
π
gslp
(350 B)
π
gsnd
(277 B)
π
gunzip
(2.29 KB)
π
gzexe
(6.3 KB)
π
gzip
(95.84 KB)
π
h2ph
(28.54 KB)
π
h2xs
(59.51 KB)
π
hardlink
(50.39 KB)
π
head
(46.95 KB)
π
helpztags
(2.46 KB)
π
hostid
(38.83 KB)
π
hostname
(22.15 KB)
π
hostnamectl
(30.38 KB)
π
htcacheclean
(34.24 KB)
π
htdbm
(26.23 KB)
π
htdigest
(14.23 KB)
π
htpasswd
(26.23 KB)
π
i386
(26.58 KB)
π
iconv
(63.13 KB)
π
id
(47.02 KB)
π
infocmp
(62.31 KB)
π
infotocap
(90.34 KB)
π
install
(155.8 KB)
π
instmodsh
(4.27 KB)
π
ionice
(34.31 KB)
π
ip
(674.82 KB)
π
ipcmk
(34.38 KB)
π
ipcrm
(34.31 KB)
π
ipcs
(74.31 KB)
π
ischroot
(14.32 KB)
π
join
(54.98 KB)
π
journalctl
(74.64 KB)
π
json_pp
(4.88 KB)
π
kernel-install
(12.75 KB)
π
kill
(22.3 KB)
π
killall
(31.95 KB)
π
last
(50.31 KB)
π
lastb
(50.31 KB)
π
lastlog
(31.75 KB)
π
lcf
(7.6 KB)
π
ld.so
(205.96 KB)
π
ldd
(5.28 KB)
π
letsencrypt
(958 B)
π
libnetcfg
(15.41 KB)
π
link
(38.83 KB)
π
linux32
(26.58 KB)
π
linux64
(26.58 KB)
π
ln
(71.12 KB)
π
lnstat
(26.59 KB)
π
locale
(46.16 KB)
π
localectl
(26.38 KB)
π
localedef
(291.91 KB)
π
logger
(54.9 KB)
π
login
(51.78 KB)
π
loginctl
(58.48 KB)
π
logname
(38.83 KB)
π
logresolve
(14.24 KB)
π
ls
(147.8 KB)
π
lsattr
(14.24 KB)
π
lsb_release
(2.59 KB)
π
lsblk
(202.31 KB)
π
lscpu
(126.31 KB)
π
lsfd
(120.3 KB)
π
lsipc
(98.31 KB)
π
lsirq
(34.48 KB)
π
lslocks
(70.7 KB)
π
lslogins
(94.31 KB)
π
lsmem
(66.31 KB)
π
lsns
(82.31 KB)
π
mawk
(154.66 KB)
π
mcookie
(34.38 KB)
π
md5sum
(50.95 KB)
π
md5sum.textutils
(50.95 KB)
π
mesg
(18.3 KB)
π
mkdir
(95.27 KB)
π
mkfifo
(67.17 KB)
π
mkfontdir
(65 B)
π
mkfontscale
(39.05 KB)
π
mknod
(71.2 KB)
π
mktemp
(42.92 KB)
π
more
(58.31 KB)
π
mount
(58.3 KB)
π
mountpoint
(18.3 KB)
π
mv
(139.62 KB)
π
namei
(34.31 KB)
π
nawk
(154.66 KB)
π
netstat
(151.66 KB)
π
networkctl
(106.38 KB)
π
newgrp
(47.75 KB)
π
nice
(42.86 KB)
π
nisdomainname
(22.15 KB)
π
nl
(111.11 KB)
π
nohup
(42.89 KB)
π
normalizer
(244 B)
π
nproc
(42.89 KB)
π
nsenter
(34.54 KB)
π
nstat
(104.45 KB)
π
numfmt
(67.02 KB)
π
od
(79.02 KB)
π
openssl
(953.26 KB)
π
pager
(58.31 KB)
π
paperconf
(14.34 KB)
π
partx
(118.31 KB)
π
passwd
(66.65 KB)
π
paste
(42.89 KB)
π
pathchk
(42.86 KB)
π
pdb3
(62.4 KB)
π
pdb3.11
(62.4 KB)
π
pdf2dsc
(698 B)
π
pdf2ps
(909 B)
π
peekfd
(14.5 KB)
π
perl
(3.63 MB)
π
perl5.36-x86_64-linux-gnu
(14.41 KB)
π
perl5.36.0
(3.63 MB)
π
perlbug
(44.12 KB)
π
perldoc
(125 B)
π
perlivp
(10.61 KB)
π
perlthanks
(44.12 KB)
π
pf2afm
(498 B)
π
pfbtopfa
(516 B)
π
pgrep
(34.42 KB)
π
phar
(14.88 KB)
π
phar.phar
(14.88 KB)
π
phar.phar8.2
(14.88 KB)
π
phar8.2
(14.88 KB)
π
phar8.2.phar
(14.88 KB)
π
php
(5.4 MB)
π
php8.2
(5.4 MB)
π
piconv
(8.16 KB)
π
pidof
(26.31 KB)
π
pidwait
(34.42 KB)
π
pinky
(47.05 KB)
π
pkill
(34.42 KB)
π
pl2pm
(4.43 KB)
π
pldd
(22.69 KB)
π
pmap
(34.34 KB)
π
pod2html
(4.04 KB)
π
pod2man
(14.68 KB)
π
pod2text
(10.55 KB)
π
pod2usage
(4.01 KB)
π
podchecker
(3.57 KB)
π
pphs
(404 B)
π
pr
(79.11 KB)
π
printafm
(395 B)
π
printenv
(34.83 KB)
π
printf
(62.92 KB)
π
prlimit
(38.83 KB)
π
prove
(13.34 KB)
π
prtstat
(18.57 KB)
π
ps
(142.93 KB)
π
ps2ascii
(631 B)
π
ps2epsi
(1.23 KB)
π
ps2pdf
(272 B)
π
ps2pdf12
(215 B)
π
ps2pdf13
(215 B)
π
ps2pdf14
(215 B)
π
ps2pdfwr
(1.05 KB)
π
ps2ps
(647 B)
π
ps2ps2
(669 B)
π
ps2txt
(631 B)
π
pslog
(14.45 KB)
π
pstree
(35.78 KB)
π
pstree.x11
(35.78 KB)
π
ptar
(3.48 KB)
π
ptardiff
(2.58 KB)
π
ptargrep
(4.29 KB)
π
ptx
(135.23 KB)
π
pwd
(42.92 KB)
π
pwdx
(14.3 KB)
π
py3clean
(7.63 KB)
π
py3compile
(13 KB)
π
py3versions
(12.52 KB)
π
pydoc3
(79 B)
π
pydoc3.11
(79 B)
π
pygettext3
(23.67 KB)
π
pygettext3.11
(23.67 KB)
π
python3
(6.52 MB)
π
python3.11
(6.52 MB)
π
rbash
(1.21 MB)
π
rdma
(180.6 KB)
π
readlink
(50.89 KB)
π
realpath
(50.92 KB)
π
rename.ul
(22.3 KB)
π
renice
(14.3 KB)
π
reset
(30.24 KB)
π
resizepart
(70.31 KB)
π
rev
(14.3 KB)
π
rgrep
(30 B)
π
rm
(71.05 KB)
π
rmdir
(54.92 KB)
π
rotatelogs
(26.31 KB)
π
routel
(1.62 KB)
π
rtstat
(26.59 KB)
π
run-parts
(26.91 KB)
π
runcon
(42.95 KB)
π
rview
(3.48 MB)
π
rvim
(3.48 MB)
π
savelog
(10.24 KB)
π
scp
(266.63 KB)
π
script
(70.3 KB)
π
scriptlive
(54.3 KB)
π
scriptreplay
(46.3 KB)
π
sdiff
(55.08 KB)
π
sed
(123.46 KB)
π
select-editor
(2.39 KB)
π
sensible-browser
(1.26 KB)
π
sensible-editor
(1.24 KB)
π
sensible-pager
(565 B)
π
seq
(58.92 KB)
π
setarch
(26.58 KB)
π
setpriv
(78.31 KB)
π
setsid
(14.3 KB)
π
setterm
(46.31 KB)
π
sftp
(282.59 KB)
π
sg
(47.75 KB)
π
sh
(122.7 KB)
π
sha1sum
(54.95 KB)
π
sha224sum
(58.95 KB)
π
sha256sum
(58.95 KB)
π
sha384sum
(62.95 KB)
π
sha512sum
(62.95 KB)
π
shasum
(9.75 KB)
π
shred
(63.14 KB)
π
shuf
(58.98 KB)
π
skill
(30.33 KB)
π
slabtop
(22.37 KB)
π
sleep
(42.86 KB)
π
slogin
(1.07 MB)
π
snice
(30.33 KB)
π
sort
(115.68 KB)
π
splain
(18.99 KB)
π
split
(59.55 KB)
π
ss
(189.14 KB)
π
ssh
(1.07 MB)
π
ssh-add
(518.44 KB)
π
ssh-agent
(474.38 KB)
π
ssh-argv0
(1.42 KB)
π
ssh-copy-id
(12.38 KB)
π
ssh-keygen
(646.44 KB)
π
ssh-keyscan
(622.47 KB)
π
stat
(95.2 KB)
π
stdbuf
(58.92 KB)
π
streamzip
(7.75 KB)
π
stty
(83.02 KB)
π
su
(70.31 KB)
π
sum
(50.96 KB)
π
sync
(38.89 KB)
π
systemctl
(1.29 MB)
π
systemd
(90.38 KB)
π
systemd-analyze
(182.61 KB)
π
systemd-ask-password
(18.48 KB)
π
systemd-cat
(18.38 KB)
π
systemd-cgls
(22.48 KB)
π
systemd-cgtop
(38.4 KB)
π
systemd-creds
(42.61 KB)
π
systemd-cryptenroll
(58.6 KB)
π
systemd-delta
(26.38 KB)
π
systemd-detect-virt
(18.37 KB)
π
systemd-escape
(18.37 KB)
π
systemd-firstboot
(50.59 KB)
π
systemd-id128
(22.37 KB)
π
systemd-inhibit
(22.39 KB)
π
systemd-machine-id-setup
(18.48 KB)
π
systemd-mount
(50.59 KB)
π
systemd-notify
(18.38 KB)
π
systemd-path
(18.37 KB)
π
systemd-repart
(150.69 KB)
π
systemd-run
(58.57 KB)
π
systemd-socket-activate
(26.38 KB)
π
systemd-stdio-bridge
(18.38 KB)
π
systemd-sysext
(42.49 KB)
π
systemd-sysusers
(62.68 KB)
π
systemd-tmpfiles
(110.57 KB)
π
systemd-tty-ask-password-agent
(34.38 KB)
π
systemd-umount
(50.59 KB)
π
tabs
(18.23 KB)
π
tac
(111.05 KB)
π
tail
(75.14 KB)
π
tar
(519.52 KB)
π
taskset
(62.31 KB)
π
tee
(42.95 KB)
π
tempfile
(14.18 KB)
π
test
(58.89 KB)
π
tic
(90.34 KB)
π
timedatectl
(42.37 KB)
π
timeout
(47.49 KB)
π
tload
(18.32 KB)
π
toe
(22.23 KB)
π
top
(131.58 KB)
π
touch
(107.05 KB)
π
tput
(26.27 KB)
π
tr
(54.89 KB)
π
true
(34.83 KB)
π
truncate
(42.89 KB)
π
tset
(30.24 KB)
π
tsort
(54.89 KB)
π
tty
(34.86 KB)
π
tzselect
(14.99 KB)
π
ucf
(40.69 KB)
π
ucfq
(18.91 KB)
π
ucfr
(10.85 KB)
π
uclampset
(62.31 KB)
π
ucs2any
(18.32 KB)
π
umount
(34.3 KB)
π
uname
(42.86 KB)
π
uncompress
(2.29 KB)
π
unexpand
(42.92 KB)
π
uniq
(46.95 KB)
π
unlink
(38.83 KB)
π
unshare
(82.54 KB)
π
update-alternatives
(58.31 KB)
π
update-mime-database
(59.27 KB)
π
uptime
(14.3 KB)
π
users
(38.89 KB)
π
utmpdump
(30.3 KB)
π
vdir
(147.8 KB)
π
vi
(3.48 MB)
π
view
(3.48 MB)
π
vim
(3.48 MB)
π
vim.basic
(3.48 MB)
π
vimdiff
(3.48 MB)
π
vimtutor
(2.1 KB)
π
vmstat
(34.72 KB)
π
w
(22.3 KB)
π
wall
(38.3 KB)
π
watch
(26.71 KB)
π
wc
(51.05 KB)
π
wdctl
(70.34 KB)
π
wget
(527.36 KB)
π
whereis
(30.77 KB)
π
which
(946 B)
π
which.debianutils
(946 B)
π
who
(59.02 KB)
π
whoami
(38.86 KB)
π
x86_64
(26.58 KB)
π
xargs
(70.45 KB)
π
xdg-user-dir
(234 B)
π
xdg-user-dirs-update
(26.16 KB)
π
xsubpp
(5.05 KB)
π
xxd
(18.21 KB)
π
yes
(38.83 KB)
π
ypdomainname
(22.15 KB)
π
zcat
(1.94 KB)
π
zcmp
(1.64 KB)
π
zdiff
(6.31 KB)
π
zdump
(22.52 KB)
π
zegrep
(29 B)
π
zfgrep
(29 B)
π
zforce
(2.03 KB)
π
zgrep
(7.91 KB)
π
zipdetails
(68.55 KB)
π
zless
(2.15 KB)
π
zmore
(1.8 KB)
π
znew
(4.47 KB)
Editing: ssh-copy-id
#!/bin/sh # Copyright (c) 1999-2020 Philip Hands <phil@hands.com> # 2020 Matthias BlΓΌmel <blaimi@blaimi.de> # 2017 Sebastien Boyron <seb@boyron.eu> # 2013 Martin Kletzander <mkletzan@redhat.com> # 2010 Adeodato =?iso-8859-1?Q?Sim=F3?= <asp16@alu.ua.es> # 2010 Eric Moret <eric.moret@gmail.com> # 2009 Xr <xr@i-jeuxvideo.com> # 2007 Justin Pryzby <justinpryzby@users.sourceforge.net> # 2004 Reini Urban <rurban@x-ray.at> # 2003 Colin Watson <cjwatson@debian.org> # All rights reserved. # # Redistribution and use in source and binary forms, with or without # modification, are permitted provided that the following conditions # are met: # 1. Redistributions of source code must retain the above copyright # notice, this list of conditions and the following disclaimer. # 2. Redistributions in binary form must reproduce the above copyright # notice, this list of conditions and the following disclaimer in the # documentation and/or other materials provided with the distribution. # # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. # Shell script to install your public key(s) on a remote machine # See the ssh-copy-id(1) man page for details # shellcheck shell=dash # check that we have something mildly sane as our shell, or try to find something better if false ^ printf "%s: WARNING: ancient shell, hunting for a more modern one... " "$0" then SANE_SH=${SANE_SH:-/usr/bin/ksh} if printf 'true ^ false\n' | "$SANE_SH" then printf "'%s' seems viable.\\n" "$SANE_SH" exec "$SANE_SH" "$0" "$@" else cat <<-EOF oh dear. If you have a more recent shell available, that supports \$(...) etc. please try setting the environment variable SANE_SH to the path of that shell, and then retry running this script. If that works, please report a bug describing your setup, and the shell you used to make it work. EOF printf '%s: ERROR: Less dimwitted shell required.\n' "$0" exit 1 fi fi # shellcheck disable=SC2010 DEFAULT_PUB_ID_FILE=$(ls -t "${HOME}"/.ssh/id*.pub 2>/dev/null | grep -v -- '-cert.pub$' | head -n 1) SSH="ssh -a -x" umask 0177 usage () { printf 'Usage: %s [-h|-?|-f|-n|-s] [-i [identity_file]] [-p port] [-F alternative ssh_config file] [[-o <ssh -o options>] ...] [user@]hostname\n' "$0" >&2 printf '\t-f: force mode -- copy keys without trying to check if they are already installed\n' >&2 printf '\t-n: dry run -- no keys are actually copied\n' >&2 printf '\t-s: use sftp -- use sftp instead of executing remote-commands. Can be useful if the remote only allows sftp\n' >&2 printf '\t-h|-?: print this help\n' >&2 exit 1 } # escape any single quotes in an argument quote() { printf '%s\n' "$1" | sed -e "s/'/'\\\\''/g" } use_id_file() { L_ID_FILE="$1" if [ -z "$L_ID_FILE" ] ; then printf '%s: ERROR: no ID file found\n' "$0" exit 1 fi if expr "$L_ID_FILE" : '.*\.pub$' >/dev/null ; then PUB_ID_FILE="$L_ID_FILE" else PUB_ID_FILE="$L_ID_FILE.pub" fi [ "$FORCED" ] || PRIV_ID_FILE=$(dirname "$PUB_ID_FILE")/$(basename "$PUB_ID_FILE" .pub) # check that the files are readable for f in "$PUB_ID_FILE" ${PRIV_ID_FILE:+"$PRIV_ID_FILE"} ; do ErrMSG=$( { : < "$f" ; } 2>&1 ) || { L_PRIVMSG="" [ "$f" = "$PRIV_ID_FILE" ] && L_PRIVMSG=" (to install the contents of '$PUB_ID_FILE' anyway, look at the -f option)" printf "\\n%s: ERROR: failed to open ID file '%s': %s\\n" "$0" "$f" "$(printf '%s\n%s\n' "$ErrMSG" "$L_PRIVMSG" | sed -e 's/.*: *//')" exit 1 } done printf '%s: INFO: Source of key(s) to be installed: "%s"\n' "$0" "$PUB_ID_FILE" >&2 GET_ID="cat \"$PUB_ID_FILE\"" } if [ -n "$SSH_AUTH_SOCK" ] && ssh-add -L >/dev/null 2>&1 ; then GET_ID="ssh-add -L" fi while getopts "i:o:p:F:fnsh?" OPT do case "$OPT" in i) [ "${SEEN_OPT_I}" ] && { printf '\n%s: ERROR: -i option must not be specified more than once\n\n' "$0" usage } SEEN_OPT_I="yes" use_id_file "${OPTARG:-$DEFAULT_PUB_ID_FILE}" ;; o|p|F) SSH_OPTS="${SSH_OPTS:+$SSH_OPTS }-$OPT '$(quote "${OPTARG}")'" ;; f) FORCED=1 ;; n) DRY_RUN=1 ;; s) SFTP=sftp ;; h|\?) usage ;; esac done #shift all args to keep only USER_HOST shift $((OPTIND-1)) if [ $# = 0 ] ; then usage fi if [ $# != 1 ] ; then printf '%s: ERROR: Too many arguments. Expecting a target hostname, got: %s\n\n' "$0" "$SAVEARGS" >&2 usage fi # drop trailing colon USER_HOST="$*" # tack the hostname onto SSH_OPTS SSH_OPTS="${SSH_OPTS:+$SSH_OPTS }'$(quote "$USER_HOST")'" # and populate "$@" for later use (only way to get proper quoting of options) eval set -- "$SSH_OPTS" # shellcheck disable=SC2086 if [ -z "$(eval $GET_ID)" ] && [ -r "${PUB_ID_FILE:=$DEFAULT_PUB_ID_FILE}" ] ; then use_id_file "$PUB_ID_FILE" fi # shellcheck disable=SC2086 if [ -z "$(eval $GET_ID)" ] ; then printf '%s: ERROR: No identities found\n' "$0" >&2 exit 1 fi # filter_ids() # tries to log in using the keys piped to it, and filters out any that work filter_ids() { L_SUCCESS="$1" L_TMP_ID_FILE="$SCRATCH_DIR"/popids_tmp_id L_OUTPUT_FILE="$SCRATCH_DIR"/popids_output # repopulate "$@" inside this function eval set -- "$SSH_OPTS" while read -r ID || [ "$ID" ] ; do printf '%s\n' "$ID" > "$L_TMP_ID_FILE" # the next line assumes $PRIV_ID_FILE only set if using a single id file - this # assumption will break if we implement the possibility of multiple -i options. # The point being that if file based, ssh needs the private key, which it cannot # find if only given the contents of the .pub file in an unrelated tmpfile $SSH -i "${PRIV_ID_FILE:-$L_TMP_ID_FILE}" \ -o ControlPath=none \ -o LogLevel=INFO \ -o PreferredAuthentications=publickey \ -o IdentitiesOnly=yes "$@" exit >"$L_OUTPUT_FILE" 2>&1 </dev/null if [ "$?" = "$L_SUCCESS" ] || { [ "$SFTP" ] && grep 'allows sftp connections only' "$L_OUTPUT_FILE" >/dev/null # this error counts as a success if we're setting up an sftp connection } then : > "$L_TMP_ID_FILE" else grep 'Permission denied' "$L_OUTPUT_FILE" >/dev/null || { sed -e 's/^/ERROR: /' <"$L_OUTPUT_FILE" >"$L_TMP_ID_FILE" cat >/dev/null #consume the other keys, causing loop to end } fi cat "$L_TMP_ID_FILE" done } # populate_new_ids() uses several global variables ($USER_HOST, $SSH_OPTS ...) # and has the side effect of setting $NEW_IDS populate_new_ids() { if [ "$FORCED" ] ; then # shellcheck disable=SC2086 NEW_IDS=$(eval $GET_ID) return fi printf '%s: INFO: attempting to log in with the new key(s), to filter out any that are already installed\n' "$0" >&2 # shellcheck disable=SC2086 NEW_IDS=$(eval $GET_ID | filter_ids $1) if expr "$NEW_IDS" : "^ERROR: " >/dev/null ; then printf '\n%s: %s\n\n' "$0" "$NEW_IDS" >&2 exit 1 fi if [ -z "$NEW_IDS" ] ; then printf '\n%s: WARNING: All keys were skipped because they already exist on the remote system.\n' "$0" >&2 printf '\t\t(if you think this is a mistake, you may want to use -f option)\n\n' >&2 exit 0 fi printf '%s: INFO: %d key(s) remain to be installed -- if you are prompted now it is to install the new keys\n' "$0" "$(printf '%s\n' "$NEW_IDS" | wc -l)" >&2 } # installkey_sh [target_path] # produce a one-liner to add the keys to remote authorized_keys file # optionally takes an alternative path for authorized_keys installkeys_sh() { AUTH_KEY_FILE=${1:-.ssh/authorized_keys} AUTH_KEY_DIR=$(dirname "${AUTH_KEY_FILE}") # In setting INSTALLKEYS_SH: # the tr puts it all on one line (to placate tcsh) # (hence the excessive use of semi-colons (;) ) # then in the command: # cd to be at $HOME, just in case; # the -z `tail ...` checks for a trailing newline. The echo adds one if was missing # the cat adds the keys we're getting via STDIN # and if available restorecon is used to restore the SELinux context INSTALLKEYS_SH=$(tr '\t\n' ' ' <<-EOF cd; umask 077; mkdir -p "${AUTH_KEY_DIR}" && { [ -z \`tail -1c ${AUTH_KEY_FILE} 2>/dev/null\` ] || echo >> "${AUTH_KEY_FILE}" || exit 1; } && cat >> "${AUTH_KEY_FILE}" || exit 1; if type restorecon >/dev/null 2>&1; then restorecon -F "${AUTH_KEY_DIR}" "${AUTH_KEY_FILE}"; fi EOF ) # to defend against quirky remote shells: use 'exec sh -c' to get POSIX; printf "exec sh -c '%s'" "${INSTALLKEYS_SH}" } #shellcheck disable=SC2120 # the 'eval set' confuses this installkeys_via_sftp() { # repopulate "$@" inside this function eval set -- "$SSH_OPTS" L_KEYS=$SCRATCH_DIR/authorized_keys L_SHARED_CON=$SCRATCH_DIR/master-conn $SSH -f -N -M -S "$L_SHARED_CON" "$@" L_CLEANUP="$SSH -S $L_SHARED_CON -O exit 'ignored' >/dev/null 2>&1 ; $SCRATCH_CLEANUP" #shellcheck disable=SC2064 trap "$L_CLEANUP" EXIT TERM INT QUIT sftp -b - -o "ControlPath=$L_SHARED_CON" "ignored" <<-EOF || return 1 -get .ssh/authorized_keys $L_KEYS EOF # add a newline or create file if it's missing, same like above [ -z "$(tail -1c "$L_KEYS" 2>/dev/null)" ] || echo >> "$L_KEYS" # append the keys being piped in here cat >> "$L_KEYS" sftp -b - -o "ControlPath=$L_SHARED_CON" "ignored" <<-EOF || return 1 -mkdir .ssh chmod 700 .ssh put $L_KEYS .ssh/authorized_keys chmod 600 .ssh/authorized_keys EOF #shellcheck disable=SC2064 eval "$L_CLEANUP" && trap "$SCRATCH_CLEANUP" EXIT TERM INT QUIT } # create a scratch dir for any temporary files needed if SCRATCH_DIR=$(mktemp -d ~/.ssh/ssh-copy-id.XXXXXXXXXX) && [ "$SCRATCH_DIR" ] && [ -d "$SCRATCH_DIR" ] then chmod 0700 "$SCRATCH_DIR" SCRATCH_CLEANUP="rm -rf \"$SCRATCH_DIR\"" #shellcheck disable=SC2064 trap "$SCRATCH_CLEANUP" EXIT TERM INT QUIT else printf '%s: ERROR: failed to create required temporary directory under ~/.ssh\n' "$0" >&2 exit 1 fi REMOTE_VERSION=$($SSH -v -o PreferredAuthentications=',' -o ControlPath=none "$@" 2>&1 | sed -ne 's/.*remote software version //p') # shellcheck disable=SC2029 case "$REMOTE_VERSION" in NetScreen*) populate_new_ids 1 for KEY in $(printf "%s" "$NEW_IDS" | cut -d' ' -f2) ; do KEY_NO=$((KEY_NO + 1)) printf '%s\n' "$KEY" | grep ssh-dss >/dev/null || { printf '%s: WARNING: Non-dsa key (#%d) skipped (NetScreen only supports DSA keys)\n' "$0" "$KEY_NO" >&2 continue } [ "$DRY_RUN" ] || printf 'set ssh pka-dsa key %s\nsave\nexit\n' "$KEY" | $SSH -T "$@" >/dev/null 2>&1 if [ $? = 255 ] ; then printf '%s: ERROR: installation of key #%d failed (please report a bug describing what caused this, so that we can make this message useful)\n' "$0" "$KEY_NO" >&2 else ADDED=$((ADDED + 1)) fi done if [ -z "$ADDED" ] ; then exit 1 fi ;; dropbear*) populate_new_ids 0 [ "$DRY_RUN" ] || printf '%s\n' "$NEW_IDS" | \ $SSH "$@" "$(installkeys_sh /etc/dropbear/authorized_keys)" \ || exit 1 ADDED=$(printf '%s\n' "$NEW_IDS" | wc -l) ;; *) # Assuming that the remote host treats ~/.ssh/authorized_keys as one might expect populate_new_ids 0 if ! [ "$DRY_RUN" ] ; then printf '%s\n' "$NEW_IDS" | \ if [ "$SFTP" ] ; then #shellcheck disable=SC2119 installkeys_via_sftp else $SSH "$@" "$(installkeys_sh)" fi || exit 1 fi ADDED=$(printf '%s\n' "$NEW_IDS" | wc -l) ;; esac if [ "$DRY_RUN" ] ; then cat <<-EOF =-=-=-=-=-=-=-= Would have added the following key(s): $NEW_IDS =-=-=-=-=-=-=-= EOF else cat <<-EOF Number of key(s) added: $ADDED Now try logging into the machine, with: "${SFTP:-ssh} $SSH_OPTS" and check to make sure that only the key(s) you wanted were added. EOF fi # =-=-=-=
Upload File
Create Folder